//@author: woei
//@help: draws a mesh with different textures on front and back
//@tags: doublesided

// PARAMETERS ------------------------------------------------------------------
float4x4 tWVP: WORLDVIEWPROJECTION;

float4 cAmb : COLOR <String uiname="Color";>  = {1, 1, 1, 1};
float Alpha = 1;

texture TexF <string uiname="Texture Front";>;
sampler SampFront = sampler_state { Texture = (TexF); Filter = Min_Mag_Mip_Linear; };
texture TexB <string uiname="Texture Back";>;
sampler SampBack = sampler_state { Texture = (TexB); Filter = Min_Mag_Mip_Linear; };

float4x4 tTex: TEXTUREMATRIX <string uiname="Texture Transform";>;
float4x4 tColor <string uiname="Color Transform";>;

// VERTEXSHADERS ---------------------------------------------------------------
void VS(inout float4 Pos : POSITION, inout float4 TexCd : TEXCOORD0)
{
    Pos = mul(Pos, tWVP);
    TexCd = mul(TexCd, tTex);
}
// PIXELSHADERS ----------------------------------------------------------------
float4 PS(float4 TexCd : TEXCOORD0, float front : VFACE ): COLOR
{
    float4 col = cAmb;
	if (step(0,front))
		col *= tex2D(SampFront, TexCd);
	else
		col *= tex2D(SampBack, TexCd);
    col = mul(col, tColor);
	col.a *= Alpha;
    return col;
}
// TECHNIQUES ------------------------------------------------------------------
technique TConstantDoubleSide
{
    pass P0
    {
        VertexShader = compile vs_3_0 VS();
        PixelShader = compile ps_3_0 PS();
    }
}